#!/bin/sh
# Run cache categories script
# Author: Kim Viljanen
# CVS ID: $Id: run-cache_categories.sh,v 1.4 2003/12/18 17:25:55 kimvilja Exp $

# Setting variables. You should use $HOME/.ontodella for configurations.

if [ -e $HOME/.ontodella ]; then
    . $HOME/.ontodella
else 
    # no .ontodella configuration file, use default values...
    echo "No such file $HOME/.ontodella. Using default values.\n"
    ONTODELLA_HOME="$HOME/ontodella"     # $HOME = your home directory
    PROLOG=pl                            # Path to prolog interpreter
    PLPARAMS="-G24M -L10M -T8M"                   # Prolog params
fi

CATEGORY_DIR="$ONTODELLA_HOME/categories"         # Category directory
ODPARAMS="port=none log=cache_categories.log"    # Ontodella params

# Internal configuration
# You shouldn't need to change these...

CACHE_CATEGORY_PL="$ONTODELLA_HOME/src/perl/cache_categories.pl"



# Call cache_cateogires.pl

echo ">>> $CACHE_CATEGORY_PL $ONTODELLA_HOME $PROLOG $CATEGORY_DIR";
/usr/bin/perl $CACHE_CATEGORY_PL home=$ONTODELLA_HOME pl=$PROLOG catdir=$CATEGORY_DIR plparams="$PLPARAMS" odparams="$ODPARAMS" cparams="$1 $2 $3 $4 $5 $6 $7 $8 $9"
