#!/bin/sh
# Ontodella server start script
# Author: Arttu Valo, spoiled by Kim Viljanen
# CVS Id: $Id: run-onto.sh,v 1.10 2004/01/13 15:19:56 kimvilja Exp $


# Setting variables. You should use $HOME/.ontodella for configurations.

if [ -e $HOME/.ontodella ]; then
    . $HOME/.ontodella
else
    # no .ontodella configuration file, use default values...
    echo "No such file $HOME/.ontodella. Using default values.\n"
    ONTODELLA_HOME="$HOME/ontodella"     # $HOME = your home directory
    PROLOG=pl                            # Path to prolog interpreter
    PLPARAMS="-G24M -L10M -T8M"                   # Prolog params
fi


# internal configuration.

ONTODELLA_CONFIG="$ONTODELLA_HOME/conf/fms/ontodella_config.pl"
ONTODELLA_SERVER="$ONTODELLA_HOME/src/prolog/ontodella_server.pl"
CREATE_TEST_FILE="$ONTODELLA_HOME/src/perl/create_test_file.pl"
TEST_FILE="$ONTODELLA_HOME/conf/fms/ontodella_test.pl"

# Create test script

/usr/bin/perl $CREATE_TEST_FILE $PROLOG $ONTODELLA_CONFIG $TEST_FILE $ONTODELLA_HOME

# Start prolog httpd

echo "$PROLOG -s $ONTODELLA_SERVER $PLPARAMS -g server -- home=$ONTODELLA_HOME config=$ONTODELLA_CONFIG test_file=$TEST_FILE $1 $2 $3 $4 $5 $6 $7 $8 $9"
echo

#screen -d -m 
$PROLOG -s $ONTODELLA_SERVER $PLPARAMS -g server -- home=$ONTODELLA_HOME config=$ONTODELLA_CONFIG test_file=$TEST_FILE $1 $2 $3 $4 $5 $6 $7 $8 $9

# Above: -s prolog-file-to-load
#        -GxxxM stands for xxx MB global stack (4MB is default and insufficient)
#        -LxxxM = local stack size
#        -g prolog_goal_to_call (i.e., predicate name)
#echo "You can now attach to the prolog screen with: screen -d -r"
#echo "You can then deattach with: CTRL+a and d"

# AV: automatic caching after start-up might be available with a little
# script and wget!?

# Start tomcat
#cd ~
#start-tomcat
