%%%%%%%%%%
% SeWeHGrius Rules for Finnish Museums on the semantic Web
% (FMS a.k.a. MuseoSuomi)
%
% CVS Id: $Id: fmsweb_sewehgrius_rules.pl,v 1.39 2004/03/18 13:38:17 kimvilja Exp $
%


%:- load_files( 'sewehgrius_rdfs_core_rules' ).
%:- load_files( 'fmsweb_catskip_rules.pl' ).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% metadata about sewehgrius. for debug purposes.
%

sewehgrius_metadata('dataid', 'silent_squirrel').
sewehgrius_metadata('ruleid', '$Id: fmsweb_sewehgrius_rules.pl,v 1.39 2004/03/18 13:38:17 kimvilja Exp $').


%%%%%%%%%%
% SeWeHGrius Primary (Root) Categories
% Order defines the root category id numbers. Don't change the order!!!


%sewehgrius_category( -CategoryRootURIAtom, -CategoryLabelPredicateAtom, -SubStructuringPredicateAtom, -BookmarkPredicateAtom )
sewehgrius_category(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-masa#esineet',
    esinetyyppi_root_labels,
    mao_sub_category,
    esinetyyppi_leaf
).

sewehgrius_category(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-maoryhma#materiaalit_ja_aineet',
     materiaalit_root_labels,
     mao_sub_category,
     materiaali_leaf
).

sewehgrius_category(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-toimijat#toimijat',
    valmistaja_root_labels,
    valmistaja_subcat,
    valmistaja_leaf
).

sewehgrius_category(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-paikat#maapallo',
    valmistuspaikka_root_labels,
    valmistuspaikka_subcat,
    valmistuspaikka_leaf
).

sewehgrius_category(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-ajat#ajat',
    valmistusaika_root_labels,
    valmistusaika_subcat,
    valmistusaika_leaf
).

sewehgrius_category(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-toimijat#toimijat',
    kayttaja_root_labels,
    kayttaja_subcat,
    kayttaja_leaf
).

sewehgrius_category(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-paikat#maapallo',
    kayttopaikka_root_labels,
    kayttopaikka_subcat,
    kayttopaikka_leaf
).

sewehgrius_category(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-maoryhma#prosessit_ja_tapahtumat',
    kayttotilanne_root_labels,
    mao_sub_category,
    kayttotilanne_leaf
).

sewehgrius_category(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-kokoelmat#kokoelmat',
    kokoelmat_root_labels,
    kokoelmat_subcat,
    kokoelmat_leaf
).



%%%%%%%%%%
% SeWeHGrius Primary (Root) Relations
%


%sewehgrius_relation_rule( ?RuleURI, ?RuleLabelList, RulePredicateAtom )
sewehgrius_relation_rule(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-deduced/relation#same_user',
    [fi:'Sama kyttj', en:'Same user'],
    sama_kayttaja
).

sewehgrius_relation_rule(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-deduced/relation#same_place_of_use',
    [fi:'Sama kyttpaikka', en:'Same place of use'],
    sama_kayttopaikka
).

sewehgrius_relation_rule(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-deduced/relation#same_situation_of_use',
    [fi:'Sama kytttilanne', en:'Same situation of use'],
    sama_kayttotilanne
).

sewehgrius_relation_rule(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-deduced/relation#same_MAO_class',
    [fi:'Samaan aiheeseen liittyvi esineit', en:'Objects related to similar theme'],
    sama_masa_luokitus
).  % in practice: exact match in MAO/MASA-classification

sewehgrius_relation_rule(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-deduced/relation#same_material',
    [fi:'Sama materiaali', en:'Same material'],
    sama_materiaali
).

sewehgrius_relation_rule(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-deduced/relation#same_manufacturer',
    [fi:'Sama valmistaja', en:'Same manufacturer'],
    sama_valmistaja
).

sewehgrius_relation_rule(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-deduced/relation#same_time_of_manufacture',
    [fi:'Sama valmistusaika', en:'Same time of manufacture'],
    sama_valmistusaika
).

sewehgrius_relation_rule(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-deduced/relation#same_place_of_manufacture',
    [fi:'Sama valmistuspaikka', en:'Same place of manufacture'],
    sama_valmistuspaikka ).

sewehgrius_relation_rule(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-deduced/relation#places_cards',
    [fi:'Paikan kuvat', en:'Pictures of this place'],
    paikan_kuvat
).

sewehgrius_relation_rule(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-deduced/relation#actors_cards',
    [fi:'Toimijan kuvat', en:'Pictures of this actor'],
    toimijan_kuvat
).

sewehgrius_relation_rule(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-deduced/relations#masa_concepts_cards',
    [fi:'MASA-termin kuvat', en:'Pictures of this MASA-concept'],
    masasanan_kuvat
).

sewehgrius_relation_rule(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-deduced/relations#related_to_an_event',
    [fi:'Liittyy tapahtumaan', en:'Related to an event'],
    liittyy_tapahtumaan
).

sewehgrius_relation_rule(
    'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-deduced/relations#related_to_an_item_type',
    [fi:'Liittyy esinetyyppiin', en:'Related to an item type'],
    liittyy_esinetyyppiin
).



%%%%%%%%%%
% Sub-rules which form the above
%

%sewehgrius_relation_rule( ?RelationURI, ?RelationLabelList, RelationPredicateAtom,
%    ?ParentRelationURI )
%seweghrius_relation_rule( ??? ).


%%%%%%%%%%
% SeWeHGrius label rules
%


%esinetyyppi_root_labels( URI, LabelList )
esinetyyppi_root_labels( _, LabelList ) :-
    LabelList = [fi:'Esinetyyppi', en:'Object type'].


%materiaalit_root_labels( URI, LabelList )
materiaalit_root_labels( _, LabelList ) :-
    LabelList = [fi:'Materiaali', en:'Material'].


%valmistaja_root_labels( URI, LabelList )
valmistaja_root_labels( _, LabelList ) :-
    LabelList = [fi:'Valmistaja', en:'Manufacturer'].


%valmistuspaikka_root_labels( URI, LabelList )
valmistuspaikka_root_labels( _, LabelList ) :-
    LabelList = [fi:'Valmistuspaikka', en:'Place of manufacture'].


%valmistusaika_root_labels( URI, LabelList )
valmistusaika_root_labels( _, LabelList ) :-
    LabelList = [fi:'Valmistusaika', en:'Time of manufacture'].


%kayttaja_root_labels( URI, LabelList )
kayttaja_root_labels( _, LabelList ) :-
    LabelList = [fi:'Kyttj', en:'User'].


%kayttopaikka_root_labels( URI, LabelList )
kayttopaikka_root_labels( _, LabelList ) :-
    LabelList = [fi:'Kyttpaikka', en:'Place of use'].


%kayttotilanne_root_labels( URI, LabelList )
kayttotilanne_root_labels( _, LabelList ) :-
    LabelList = [fi:'Kytttilanne', en:'Circumstances/Situation of use'].


%kokoelmat_root_labels( URI, LabelList )
kokoelmat_root_labels( _, LabelList ) :-
    LabelList = [fi:'Kokoelma', en:'Collection'].



%sewehgrius_labels( +URI, -LabelList )
sewehgrius_labels( URI, LabelList ) :-
    toimija( URI ),
    rdf( URI, _:toimijan_nimi, literal( Label ) ),
    LabelList = [fi:Label].

sewehgrius_labels( URI, LabelList ) :-
    paikka( URI ),
    rdf( URI, _:paikan_nimi, literal( Label ) ),
    LabelList = [fi:Label].

sewehgrius_labels( URI, LabelList ) :-
    rdfs_label( URI, Label ),
    LabelList = [fi:Label].

% overflow
sewehgrius_labels( _, [] ).
%sewehgrius_labels( URI, [_:URI] ).


%%%%%%%%%%
% SeWeHGrius SELECTORS
% selector = feeds out all URIs of something that has been defined (see names of selector predicates)
%


%aika( ?SubjectURI )
aika( SubjectURI ) :-
    % last mile
    rdf_type( SubjectURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-ajat#ajat' );  % or!
    % first mile
    rdfs_subClassOf( SubjectURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-ajat#ajat' );  % or!
    % somewhere en route, case 1
    rdf_type( SubjectURI, B ),
    aika( B );  % or!
    % somewhere en route, case 2
    rdfs_subClassOf( SubjectURI, C ),
    aika( C ).


%esinekortti( ?SubjectURI )
esinekortti( SubjectURI ) :-
    rdf( SubjectURI, rdf:type, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#Esinekortti' ).

muinainen( SubjectURI ) :-
    rdf( SubjectURI, rdf:type, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-muinainen#Muinaismuistokohde' ).

% AV: FIXXX! NON-FUNCTIONAL!
%kokoelma( ?SubjectURI )
kokoelma( SubjectURI ) :-
    % last mile
    rdf_type( SubjectURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-kokoelmat#kokoelmat' );  % or!
    % first mile
    rdfs_subClassOf( SubjectURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-kokoelmat#kokoelmat' );  % or!
    % somewhere en route, case 1
    rdf_type( SubjectURI, B ),
    kokoelma( B );  % or!
    % somewhere en route, case 2
    rdfs_subClassOf( SubjectURI, C ),
    kokoelma( C ).


%paikka( ?SubjectURI )
paikka( SubjectURI ) :-
    % last mile
    rdf_type( SubjectURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-paikat#paikat' );  % or!
    % first mile
    rdfs_subClassOf( SubjectURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-paikat#paikat' );  % or!
    % somewhere en route, case 1
    rdf_type( SubjectURI, B ),
    paikka( B );  % or!
    % somewhere en route, case 2
    rdfs_subClassOf( SubjectURI, C ),
    paikka( C ).


%toimija( ?SubjectURI )
toimija( SubjectURI ) :-
    % the last mile
    rdf_type( SubjectURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-toimijat#toimijat' );  % or!
    % the first mile
    rdfs_subClassOf( SubjectURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-toimijat#toimijat' );  % or!
    % somewhere en route, case 1
    rdf_type( SubjectURI, B ),
    toimija( B );  % or!
    % somewhere en route, case 2
    rdfs_subClassOf( SubjectURI, C ),
    toimija( C ).


%masa_termi( ?SubjectURI )
masa_termi( SubjectURI ) :-
    % the last mile
    rdf_type( SubjectURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-MASA#MASAConcept' );
    % the first mile
    rdfs_subClassOf( SubjectURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-MASA#MASAConcept' ),
    % somewhere en route, case 1
    rdf_type( SubjectURI, B ),
    masa_termi( B );
    % somewhere en route, case 2
    rdfs_subClassOf( SubjectURI, C ),
    masa_termi( C ).



%%%%%%%%%%
% SeWeHGrius category branch-identification predicates
%


% All sub-classes work as MAO sub-categories
%mao_sub_category( [?]+URI, [?]-SubCategoryURI )
mao_sub_category( URI, SubCat ) :-
    OrderProperty = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-#':order,
    findall( [Order,Label,SubCatURI], 
        (
            rdfs_subClassOf( SubCatURI, URI ),
            (
                rdf( SubCatURI, OrderProperty, literal(Order));
                not( rdf( SubCatURI, OrderProperty, literal(Order)) ),
                Order=0
            ),
	    not( SubCatURI == URI ),  % protection/insurance for idiot-modeller-syndrome :(
	    rdfs_label( SubCatURI, Label )
        ),
        SubCats
    ),

    sort(SubCats, SubCatsSorted),
    member( [_,_,SubCat], SubCatsSorted ).


%valmistaja_subcat( [?]+URI, [?]-SubCategoryURI )
valmistaja_subcat( URI, SubCatURI ) :-
    toimija( SubCatURI ),
    not( SubCatURI == URI ),  % protection/insurance for idiot-modeller-syndrome :(
    rdfs_subClassOf( SubCatURI, URI );  % or!
    % the last level of categories are instances
    toimija( SubCatURI ),
    rdf_type( SubCatURI, URI ).

%valmistuspaikka_subcat( URI, SubCategoryURI )
valmistuspaikka_subcat( URI, SubCategoryURI ) :-
    paikka_subcategory( URI, SubCategoryURI ).
%    rdf( SubCatURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-paikat#':paikan_kokonaisuus, URI ),
%    not( SubCatURI == URI ).  % protection/insurance for idiot-modeller-syndrome :(
%    % must have a card having SubCatURI as a valmistuspaikka (place of manufacture)
%    (
%        % direct instances
%        rdf( _, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':valmistuspaikka, SubCatURI );
%
%        % tai: vlillisi kyttpaikkoja alikategoriassa
%        valmistuspaikka_subcat( SubCatURI, A ),
%        valmistuspaikka_subcat( A, _ )
%    ).


% Sub-category predicate for times, basicly just a placeholder for now
%valmistusaika_subcat( [?]+URI, [?]-SubCategoryURI )
valmistusaika_subcat( URI, SubCategoryURI ) :-
%    aika( SubCategoryURI ),
    rdfs_subClassOf( SubCategoryURI, URI ),
    not( SubCategoryURI == URI ).  % protection/insurance for idiot-modeller-syndrome :(


%kayttaja_subcat( [?]+URI, [?]-SubCategoryURI )
kayttaja_subcat( URI, SubCategoryURI ) :-
%    toimija( SubCategoryURI ),
    not( SubCategoryURI == URI ),  % protection/insurance for idiot-modeller-syndrome :(
    rdfs_subClassOf( SubCategoryURI, URI );  % or!
    % the last level of categories actually are of type of the upper level
%    rdfs_class( URI, _ ),
    rdf_type( SubCategoryURI, URI ).


%kayttopaikka_subcat( URI, SubCategoryURI )
kayttopaikka_subcat( URI, SubCategoryURI ) :-
    paikka_subcategory( URI, SubCategoryURI ).
%    rdf( SubCatURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-paikat#':paikan_kokonaisuus, URI ),
%    not( SubCatURI == URI ).  % protection/insurance for idiot-modeller-syndrome :(
%    % must have a card having SubCatURI as a kayttopaikka (place of use)
%    (
%        % direct places of usage in subcategories
%        rdf( _, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':kayttopaikka, SubCatURI );
%
%        % or indirect places of usage in subcategories
%        kayttopaikka_subcat( SubCatURI, A ),
%        kayttopaikka_subcat( A, _ )
%    ).


% Sub-category predicate for (museum, arts and collectors') collections
%kokoelmat_subcat( [?]+URI, [?]-SubCategoryURI )
kokoelmat_subcat( URI, SubCategoryURI ) :-
%    kokoelma( SubCategoryURI ),
    not( SubCategoryURI == URI ),  % protection/insurance for idiot-modeller-syndrome :(
    rdfs_subClassOf( SubCategoryURI, URI );  % or!
    rdf_type( SubCategoryURI, URI ).


% Yleinen paikkahierarkian alikategoriasnt
paikka_subcategory( URI, SubCategoryURI ) :-
    paikka( SubCategoryURI ),
    rdf( SubCategoryURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-paikat#':kokonaisuus, URI ),
    not( SubCategoryURI == URI ).  % protection/insurance for idiot-modeller-syndrome :(



%%%%%%%%%%
% SeWeHGrius category leaf-identifying predicates
%


esinetyyppi_leaf( BookmarkURI, URI ) :-
    rdf( BookmarkURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':kohde, URI ),
    esinekortti( BookmarkURI ).

materiaali_leaf( BookmarkURI, URI ) :-
    rdf( BookmarkURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':materiaali, URI ),
    esinekortti( BookmarkURI ).

esinekortilla_suhde_uriin( BookmarkURI, URI ) :-
    rdf( BookmarkURI, _, URI ),
    esinekortti( BookmarkURI ).


valmistaja_leaf( BookmarkURI, URI ) :-
    toimija( URI ),
    rdf( BookmarkURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':tekija, URI ).


valmistuspaikka_leaf( BookmarkURI, URI ) :-
    paikka( URI ),
    rdf( BookmarkURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':valmistuspaikka, URI ).


% Valmistusaika leaf:  AIKA = URI, KORTTI = BookmarkURI
% AIKA:_:ajan_alkuvuosi <= KORTTI:_:valmistusaika_alku <= AIKA:_:ajan_loppuvuosi
%   or
% AIKA:_:ajan_loppuvuosi <= KORTTI:_:valmistusaika_loppu <= AIKA:_:ajan_loppuvuosi
%valmistusaika_leaf( BookmarkURI, URI )
valmistusaika_leaf( BookmarkURI, URI ) :-
%    aika( URI ),

    timeinstance( URI, TimeStart, TimeEnd ),

    % check that comparison times really exist
    nonvar( TimeStart ),
    nonvar( TimeEnd ),

    !,

    esinekortti( BookmarkURI ), % test and generate... 

    esineen_valmistusaika( BookmarkURI, EsineenAlkuVuosi, EsineenLoppuVuosi ),

    timeinterval_includes( TimeStart, TimeEnd, EsineenAlkuVuosi, EsineenLoppuVuosi ),

% check that the time instance's class does not have a subclass that would have a instance which would
% include in it's timeinterval the potential Bookmark ...

    forall(
    (
	rdfs_transitive_subClassOf( TimeSubClass, URI ),
	timeinstance( TimeSubClass, TimeStartSc, TimeEndSc )
    ),
    (
        not(timeinterval_includes( TimeStartSc, TimeEndSc, EsineenAlkuVuosi, EsineenLoppuVuosi ))
    )),


%writef( 'Would make bm %w %w\n', [URI, BookmarkURI] ),

    % finally: do not do a bookmark, if there is a sub-class where it
    % will be created too (prevent doubles)
    not( subclass_suits_valmistusaika( URI, BookmarkURI ) ).

%format('RETURN: valmistusaika_leaf(~w, ~w)~n', [BookmarkURI, URI]).

timeinstance( URI, TimeStart, TimeEnd ) :-
    % get instance of the given time
    rdf_type( AjanIlmentyma, URI ),
    % dig out the start and end times from the instance
    rdf( AjanIlmentyma, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-ajat#':ajan_alkuvuosi, literal( AjanAlkuVuosiAtom ) ),
    atom_to_integer( AjanAlkuVuosiAtom, TimeStart ),
    rdf( AjanIlmentyma, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-ajat#':ajan_loppuvuosi, literal( AjanLoppuVuosiAtom ) ),
    atom_to_integer( AjanLoppuVuosiAtom, TimeEnd ).

timeinterval_includes( TimeStart, TimeEnd, CardStart, CardEnd ) :-
    nonvar( TimeStart ),
    nonvar( TimeEnd ),
    nonvar( CardStart ),
    nonvar( CardEnd ),
    (
	% joko alkuvuoden osuttava alueelle ...
	TimeStart =< CardStart,
	CardStart =< TimeEnd, 
	!;

	% tai loppuvuoden osuttava alueelle ...
	TimeStart =< CardEnd,
	CardEnd =< TimeEnd, 
	!;

	% tai jokin vliin osuva viel pienempi ajanhetki
	CardStart =< TimeStart,
	TimeEnd =< CardEnd,
	!
   ).


% esineen_valmistusaika( +korttiURI, -EsineenAlkuVuosi, -EsineenLoppuVuosi )
esineen_valmistusaika( KorttiURI, EsineenAlkuVuosi, EsineenLoppuVuosi ) :-
    nonvar( KorttiURI ),
    var( EsineenAlkuVuosi ),
    var( EsineenLoppuVuosi ),

    findall( EsineenAlkuVuosi2, 
    (
        rdf( KorttiURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':valmistusaika_alku, literal( EsineenAlkuVuosiAtom2 ) ),
        atom_to_integer( EsineenAlkuVuosiAtom2, EsineenAlkuVuosi2 )
    ), AlkuVuodet ),

    findall( EsineenLoppuVuosi2,
    (
        rdf( KorttiURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':valmistusaika_loppu, literal( EsineenLoppuVuosiAtom2 ) ),
        atom_to_integer( EsineenLoppuVuosiAtom2, EsineenLoppuVuosi2 )
    ), LoppuVuodet ),

    !,

    % pick a start year

    rdf( KorttiURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':valmistusaika_alku, literal( EsineenAlkuVuosiAtom ) ),
    atom_to_integer( EsineenAlkuVuosiAtom, EsineenAlkuVuosi ),
    nth0(I, AlkuVuodet, EsineenAlkuVuosi),
    nth0(I, LoppuVuodet, EsineenLoppuVuosi),

    EsineenAlkuVuosi =< EsineenLoppuVuosi,

    nonvar( KorttiURI ),
    nonvar( EsineenAlkuVuosi ),
    nonvar( EsineenLoppuVuosi ).



kayttaja_leaf( BookmarkURI, URI ) :-
    toimija( URI ),
    rdf( BookmarkURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':kayttaja, URI ).


kayttopaikka_leaf( BookmarkURI, URI ) :-
    paikka( URI ),
    rdf( BookmarkURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':kayttopaikka, URI ).


kayttotilanne_leaf( BookmarkURI, URI ) :-
    % esinekortilla on mao-termi, joka viittaa URIn asiaan
    rdf( BookmarkURI, _:asiasana, URI );
    rdf( Mao, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-masamapping#':liittyy_tapahtumaan, URI ),
    rdf( BookmarkURI, _:asiasana, Mao );
    rdf( BookmarkURI, _:tekniikka, URI ).


kokoelmat_leaf( BookmarkURI, URI ) :-
%    kokoelma( URI ),
    rdf( BookmarkURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':museokokoelma, URI ).



%%%%%%%%%%
% (Category Visibility Constraining
%


%sewehgrius_category_is_viewable( +CategoryURI )
sewehgrius_category_is_viewable( CategoryURI ) :-
    not( sewehgrius_dont_show( CategoryURI ) ).



%%%%%%%%%%
% Relation rule implementations(?)
%


% Any two esinekortti's which don't have an "unknown" as their
% place of use should be linked
%sama_kayttopaikka( ?SubjectURI, ?RelationInstanceURI, ?TargetURI )
sama_kayttopaikka( SubjectURI, RelationDescription, TargetURI ) :- %, TextEquivalentList ) :-
    PropertyURI = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':kayttopaikka,
    rdf( SubjectURI, PropertyURI, RelationInstanceURI ),
    rdf( TargetURI, PropertyURI, RelationInstanceURI ),
    not( some_instance_of_unknown( RelationInstanceURI ) ),
    esinekortti( SubjectURI ),
    esinekortti( TargetURI ),
    SubjectURI \= TargetURI,
    list_labels( [RelationInstanceURI], RelLabel ),
    RelationDescription=[commonResources(RelationInstanceURI), label(fi:RelLabel)],
    true.
%    not( sewehgrius_super_relation_between( Subject, Relation, Target ) ),
    % do not report higher level relations, when lower-level ones exist
%    not( (
%        rdf( SubjectURI, PropertyURI, PropertyValue2 ),
%        rdf( TargetURI, PropertyURI, PropertyValue2 ),
%        (
%            rdfs_superClassOf( RelationInstanceURI, PropertyValue2 );
%            rdf_type( PropertyValue2, RelationInstanceURI )
%        )
%    ) ),
%    rdfs_label( RelationInstanceURI, TextEquivalent ),
%    TextEquivalentList = [fi:TextEquivalent].


%sama_kayttotilanne( ?SubjectURI, ?RelationInstanceURI, ?TargetURI )
sama_kayttotilanne( SubjectURI, RelationDescription, TargetURI ) :-
    PropertyURI = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti':liittyy_tapahtumaan,

    (
        % identically annotated
        rdf( SubjectURI, PropertyURI, RelationInstanceURI ),
        rdf( TargetURI, PropertyURI, RelationInstanceURI );

        % annotations related through masa#related_term
        rdf( SubjectURI, PropertyURI, RelationInstanceURI ),
        rdf( TargetURI, PropertyURI, TargetRIURI ),
        masa_related_term( RelationInstanceURI, TargetRIURI )
    ),
    SubjectURI \= TargetURI,
    list_labels( [RelationInstanceURI], RelLabel ),
    RelationDescription=[commonResources(RelationInstanceURI), label(fi:RelLabel)].


%sama_valmistaja( SubjectURI, RelationInstanceURI, TargetURI )
sama_valmistaja( SubjectURI, RelationDescription, TargetURI ) :-
    PropertyURI = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':valmistaja,
    rdf( SubjectURI, PropertyURI, RelationInstanceURI ),
    rdf( TargetURI, PropertyURI, RelationInstanceURI ),
    % the common property must not be any kind of unknown
    not( some_instance_of_unknown( RelationInstanceURI ) ),
    esinekortti( SubjectURI ),
    esinekortti( TargetURI ),
    SubjectURI \= TargetURI,
    list_labels( [RelationInstanceURI], RelLabel ),
    RelationDescription=[commonResources(RelationInstanceURI), label(fi:RelLabel)].


% Times must match *exactly*.
%sama_valmistusaika( ?SubjectURI, ?RelationInstanceURI, ?TargetURI )
sama_valmistusaika( SubjectURI, RelationDescription, TargetURI ) :-
    % times must match *exactly*
    rdf( SubjectURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':valmistusaika_alku, AlkuVuosi ),
    rdf( TargetURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':valmistusaika_alku, AlkuVuosi ),
    rdf( SubjectURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':valmistusaika_loppu, LoppuVuosi ),
    rdf( TargetURI, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':valmistusaika_loppu, LoppuVuosi ),
    SubjectURI \= TargetURI,  % AV: this must be after the rdf/3's, dunno why
%    RelationInstanceURI = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-no-URI-for-times-available',
    nonvar( AlkuVuosi ),
    nonvar( LoppuVuosi ),
    AlkuVuosi=literal(AlkuVuosiL),
    LoppuVuosi=literal(LoppuVuosiL),
    (
        AlkuVuosi\=LoppuVuosi,
        sformat( DescLabel, '~w-~w', [AlkuVuosiL, LoppuVuosiL] ),
        string_to_atom( DescLabel, DescLabelA ),
        RelationDescription=[commonResources([AlkuVuosi,LoppuVuosi]),label(DescLabelA)];
        AlkuVuosi=LoppuVuosi,
        RelationDescription=[commonResources([AlkuVuosi]), label(AlkuVuosiL)]
    ).


% Any two esinekortti's which don't have an "unknown" as their
% place of manufacture should be linked
%sama_valmistuspaikka( ?SubjectURI, ?RelationInstanceURI, ?TargetURI )
sama_valmistuspaikka( SubjectURI, RelationDescription, TargetURI ) :-
    PropertyURI = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':valmistuspaikka,
    rdf( SubjectURI, PropertyURI, RelationInstanceURI ),
    rdf( TargetURI, PropertyURI, RelationInstanceURI ),
    not( some_instance_of_unknown( RelationInstanceURI ) ),
    esinekortti( SubjectURI ),
    esinekortti( TargetURI ),
    SubjectURI \= TargetURI,
    list_labels( [RelationInstanceURI], RelLabel ),
    RelationDescription=[commonResources(RelationInstanceURI), label(fi:RelLabel)].


%sama_kayttaja( SubjectURI, RelationInstanceURI, TargetURI )
sama_kayttaja( SubjectURI, RelationDescription, TargetURI ) :-
    PropertyURI = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':kayttaja,
    rdf( SubjectURI, PropertyURI, RelationInstanceURI ),
    rdf( TargetURI, PropertyURI, RelationInstanceURI ),
    not( some_instance_of_unknown( PropertyURI ) ),
    esinekortti( SubjectURI ),
    esinekortti( TargetURI ),
    SubjectURI \= TargetURI,
    list_labels( [RelationInstanceURI], RelLabel ),
    RelationDescription=[commonResources(RelationInstanceURI), label(fi:RelLabel)].


% Same material is link recommended if there is at least 50%
% materials match.
%sama_materiaali( SubjectURI, RelationInstanceURI, TargetURI )
sama_materiaali( SubjectURI, RelationDescription, TargetURI ) :-
% SubjectMaterials
    PropertyURI = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':materiaali,
    % basic checks
    esinekortti( SubjectURI ),
%    esinekortti( TargetURI ),
%    SubjectURI \= TargetURI,

    % Find all materials for both subject and object
    findall(
        SubjectMaterialURI,
        (
            rdf( SubjectURI, PropertyURI, SubjectMaterialURI ),
            not( skip_material( SubjectMaterialURI ))
        ),
        SubjectMaterials
    ),
    length( SubjectMaterials, SubjectMaterialCount ),
    SubjectMaterialCount>0,
    setof( ObURI, ObURI^MatURI^(
        member( MatURI, SubjectMaterials ),
        rdf( ObURI, PropertyURI, MatURI ),
        esinekortti( ObURI )
        ),
        PotentialObjects ),
    length( PotentialObjects, PotObjLength ),
    PotObjLength > 0,
    member( TargetURI, PotentialObjects ),
    findall(
        ObjectMaterialURI,
        (
            rdf( TargetURI, PropertyURI, ObjectMaterialURI ),
            not( skip_material( ObjectMaterialURI ))
        ),
        TargetMaterials
    ),
    length( TargetMaterials, ObjectMaterialCount ),
    ObjectMaterialCount>0,

    % now compare the material lists
    intersection( SubjectMaterials, TargetMaterials, SameMaterials ),
    length( SameMaterials, SameMaterialCount ),
    MaterialSimilarity is SameMaterialCount / SubjectMaterialCount,
    MaterialSimilarity >= 0.5,  % at least half must match

    list_labels( SameMaterials, '', MaterialLabel ),

    RelationDescription=[commonResources(SameMaterials), label(fi:MaterialLabel)]

%    % figure out some labels or foobar-stuff for the RelationInstanceURI
%    (
%        % if only one material, this is easy: pick its URI
%        SubjectMaterialCount =:= 1,
%        rdf( SubjectURI, RelationInstanceURI, TargetURI );
%
%        % otherwise ... FIXXX: somebody should think this further
%        RelationInstanceURI = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-some-combo-material/cannot-show-single-URI',
%        RelationInstanceURI=SubjectMaterials
%    )
.


% skip these materials when creating recommendations
skip_material( 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-masa#materiaalit' ).

list_labels( List, Labels ) :-
    list_labels( List, '', Labels ).

list_labels( [], X, X ). 

list_labels( [Head|Tail], In, Out ) :-
    rdfs_label( Head, Label ),         %%% TODO: xml:lang
    (
        In='',
        Out2=Label;
        sformat( Out2, '~w, ~w', [In, Label] )
    ),
    !,
    list_labels( Tail, Out2, Out3 ),
    string_to_atom( Out3, Out ).


% If there is a term used to describe both of these, they should have
% the link recommended (UI will decide how to handle the flood of
% hundreds of recommended links).
%sama_masa_luokitus( SubjectURI, RelationInstanceURI, TargetURI ) :-
sama_masa_luokitus( SubjectURI, RelationDescription, TargetURI ) :-
    PropertyURI = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':asiasana,
    rdf( SubjectURI, PropertyURI, RelationInstanceURI ),
    rdf( TargetURI, PropertyURI, RelationInstanceURI ),
    esinekortti( SubjectURI ),
    esinekortti( TargetURI ),
    SubjectURI \= TargetURI,
    list_labels( [RelationInstanceURI], RelLabel ),
    RelationDescription=[commonResources(RelationInstanceURI), label(fi:RelLabel)].


paikan_kuvat( SubjectURI, RelationDescription, TargetURI ) :-
    paikka( SubjectURI ),
    esinekortti( TargetURI ),
    rdf( TargetURI, RelationInstanceURI, SubjectURI ).  % they are related to this place


toimijan_kuvat( SubjectURI, RelationDescription, TargetURI ) :-
    rdf( TargetURI, RelationInstanceURI, SubjectURI ),
    toimija( SubjectURI ),
    esinekortti( TargetURI ).


masasanan_kuvat( SubjectURI, RelationDescription, TargetURI ) :-
    rdf( TargetURI, RelationInstanceURI, SubjectURI ),
    masa_termi( SubjectURI ),
    esinekortti( TargetURI ).


%sewehgrius_relation( Subject, Predicate, Object, TextEquivalent ) :-
%    esinekortti( Subject ),
%    Predicate = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-web/dynamic/relation#same_class',
%    esinekortti( Object ),
%    Subject \= Object,
%    sewehgrius_relation_same_class( Subject, Object ),
%    TextEquivalent = 'Sama luokka'.

    % each mediacard has links to ??? randomizer ...
%%    esinekortti( Subject ),
%%    Predicate = 'http://www.cs.helsinki.fi/group/seco/sewehgrius#same_person',
%%    esinekortti( Object ),
%    rdf( Subject2, _, Object ),
%%    Object \= Subject,
%%    TextEquivalent = 'Sama henkil'.
%writef( 'S, P, O: %w %w %w\n', [Subject, Predicate, Object] ).
%    rdf( Subject, Predicate, Object ),
%    rdf( Subject, 'http://www.w3.org/TR/1999/PR-rdf-schema-19990303#':label , literal( TextEquivalent ) ).


% Relation-rule for picking out the www_-starting description texts
%annotaatiot( SubjectURI, RelationInstanceURI, TargetURI, TextEquivalentList )
annotaatiot( SubjectURI, RelationInstanceURI, TargetURI ) :- %, TextEquivalentList ) :-
    % Below: RelationInstanceURI is non-atomic (Namespace:Localname)
    rdf( SubjectURI, RelationInstanceURI, literal( LiteralValue ) ),
    TargetURI = LiteralValue.  % it does not exits, this is a literal
%    TextEquivalentList = [fi:LiteralValue].

% Relation-rule for picking out non-www_-starting annotation uris and
% their respective labels
annotaatiot( SubjectURI, RelationInstanceURI, TargetURI ) :- %, TextEquivalentList ) :-
    rdf( SubjectURI, RelationInstanceURI, TargetURI ),
    TargetURI \= literal( _ ).  % it must not be a literal! (it must be URI)
%    rdfs_label( TargetURI, TargetLabel ),
%    TextEquivalentList = [fi:TargetLabel].



% Relation rule based on the "uudetsaannot2004-01-07.rdf" data which 
% connects items to events.

% e mapping:liittyy_tapahtumaan r        r kuuluu tapahtumat-ontologiaan
% e liittyy_esineeseen r       r kuuluu esineet-ontologiaan
% e liittyy_materiaaliin r       r kuuluu materiaalit-ontologiaan
%
% Oletaan e1 liittyy_xxx r1 & e2 liittyy_xxx r2. Tllin jokainen rdf-kortti-instanssi i1 ja i2, jonka
% esinetyyppi on e1 ja e2, liittyy vastaavasti toisiinsa. Voidaan suositella i1->i2 ja i2->i1 jos ptee:
% 1) r1=r2 tai r1<r2 (r2<r1), jolloin yhdistv luokka on r2 (r1), ja
% 2) not(e1<e2) and not(e2<e1), eli eivt toistensa aliluokkia (nm lytyvt kategoriapuusta muutenkin)
%
% liittyy_esineeseen on symmetrinen relaatio: a liittyy_esineeseen b -> b liittyy_esineeseen a

%liittyy_tapahtumaan( ?SubjectURI, ?RelationInstanceURI, ?TargetURI )
liittyy_tapahtumaan( SubjectURI, RelationDescription, TargetURI ) :-
    PropertyURI = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-masamapping#':liittyy_tapahtumaan,
    KohdePropertyURI = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':kohde,
    esinekortti( SubjectURI ),
    rdf( SubjectURI, KohdePropertyURI, SubjectEsinetyyppiURI ),
    (
        SubjectEsinetyyppiURI1=SubjectEsinetyyppiURI;
        rdfs_transitive_subClassOf( SubjectEsinetyyppiURI, SubjectEsinetyyppiURI1, cache_or_direct)
    ),
    rdf( SubjectEsinetyyppiURI1, PropertyURI, RelationInstanceURI1 ),
    (
        RelationInstanceURI1 = RelationInstanceURI2,
	DescResource=RelationInstanceURI1;
        rdfs_transitive_subClassOf( RelationInstanceURI1, RelationInstanceURI2, cache_or_direct ),
	DescResource=RelationInstanceURI2;
        rdfs_transitive_subClassOf( RelationInstanceURI2, RelationInstanceURI1, cache_or_direct ),
	DescResource=RelationInstanceURI1
    ),
    rdf( TargetEsinetyyppiURI1, PropertyURI, RelationInstanceURI2 ),
    (
        TargetEsinetyyppiURI=TargetEsinetyyppiURI1;
        rdfs_transitive_subClassOf( TargetEsinetyyppiURI, TargetEsinetyyppiURI1, cache_or_direct )
    ),
    TargetEsinetyyppiURI \= SubjectEsinetyyppiURI,
    not( rdfs_transitive_subClassOf( TargetEsinetyyppiURI, SubjectEsinetyyppiURI, cache_or_direct )),
    not( rdfs_transitive_subClassOf( SubjectEsinetyyppiURI, TargetEsinetyyppiURI, cache_or_direct )),
    rdf( TargetURI, KohdePropertyURI, TargetEsinetyyppiURI ),
    SubjectURI \= TargetURI,
    esinekortti( TargetURI ),
    list_labels( [DescResource], RelLabel ),
    RelationDescription=[commonResources(DescResource), label(fi:RelLabel)].



% Jos kuuluu esineluokkaan niin liittyy toiseen esineluokkaan (sama teema eri hierarkia.
%
% Kli-esimerkki:
% Liityy esinetyyppiin                // Otsikko
% Yhdistv tekij: sota-aseet       // Yhdistv luokka
%   pyssy                            // Linkki esinekorttiin
%   sotilaspuku
%   ...


%liittyy_tapahtumaan( ?SubjectURI, ?RelationInstanceURI, ?TargetURI )
liittyy_esinetyyppiin( SubjectURI, RelationDescription, TargetURI ) :-
    PropertyURI = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-masamapping#':liittyy_luokkaan,
    KohdePropertyURI = 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':kohde,
    esinekortti( SubjectURI ),
    rdf( SubjectURI, KohdePropertyURI, SubjectEsinetyyppiURI ),
    (
        SubjectEsinetyyppiURI1=SubjectEsinetyyppiURI;
        rdfs_transitive_subClassOf( SubjectEsinetyyppiURI, SubjectEsinetyyppiURI1, cache_or_direct )
    ),
    rdf( SubjectEsinetyyppiURI1, PropertyURI, RelationInstanceURI1 ),
    (
        RelationInstanceURI1 = RelationInstanceURI2,
	DescResource=RelationInstanceURI1;
        rdfs_transitive_subClassOf( RelationInstanceURI1, RelationInstanceURI2, cache_or_direct ),
	DescResource=RelationInstanceURI2;
        rdfs_transitive_subClassOf( RelationInstanceURI2, RelationInstanceURI1, cache_or_direct ),
	DescResource=RelationInstanceURI1
    ),
    rdf( TargetEsinetyyppiURI1, PropertyURI, RelationInstanceURI2 ),
    (
        TargetEsinetyyppiURI=TargetEsinetyyppiURI1;
        rdfs_transitive_subClassOf( TargetEsinetyyppiURI, TargetEsinetyyppiURI1)
    ),
    nonvar(TargetEsinetyyppiURI), 
    nonvar(SubjectEsinetyyppiURI),
    TargetEsinetyyppiURI \= SubjectEsinetyyppiURI,
    not( rdfs_transitive_subClassOf( TargetEsinetyyppiURI, SubjectEsinetyyppiURI, cache_or_direct )),
    not( rdfs_transitive_subClassOf( SubjectEsinetyyppiURI, TargetEsinetyyppiURI, cache_or_direct )),
    rdf( TargetURI, KohdePropertyURI, TargetEsinetyyppiURI ),
    SubjectURI \= TargetURI,
    esinekortti( TargetURI ),
    list_labels( [DescResource], RelLabel1 ),
    sformat( RelLabel, 'yhdistv tekij: ~w', [RelLabel1] ),
    RelationDescription=[commonResources(DescResource), label(fi:RelLabel)].




%%%%%%%%%%
% SeWeHGrius Annotations
%


%sewehgrius_annotation( +SubjectURI, -Namespace, -PropertyName, -PropertyValue )
sewehgrius_annotation( SubjectURI, Namespace, PropertyName, PropertyValue ) :-
    % literals named as such
    rdf( SubjectURI, Namespace:PropertyName, PropertyValue ).

%sewehgrius_annotation( SubjectURI, Namespace, PropertyName, PropertyValue ) :-
    % non-literals named as such
%    rdf( SubjectURI, Namespace:PropertyName, PropertyValue ),
%    PropertyValue \= literal( _ ).

sewehgrius_annotation( SubjectURI, 'http://localserver.org/deduced/annotations#', 'title', PropertyValue ) :-
    rdf( SubjectURI, _:www_esinenimi, PropertyValue ).

sewehgrius_annotation( SubjectURI, 'http://localserver.org/deduced/annotations#', 'pictureurl', PropertyValue ) :-
    rdf( SubjectURI, _:www_kuvatiedostonimi, PropertyValue ).



%%%%%%%%%%
% Auxiliary predicates
%


% Succeeds when URI reprepsents an unknown (their labels started
% with '?' at the time this was first written).
%some_instance_of_unknown( ?URI )
some_instance_of_unknown( URI ) :-
    string_to_atom( QstMark, '?' ),
    (
        % either the place is a part of an unknown place
        rdf( URI, _:paikan_kokonaisuus, Kokonaisuus ),
        rdfs_label( Kokonaisuus, Label );

        % or it is already an unknown as such
        rdfs_label( URI, Label )
    ),
    sub_string( Label, 0, 1, _, QstMark ).


subclass_suits_valmistusaika( URI, BookmarkURI ) :-
    rdfs_subClassOf( ShorterTimeClassURI, URI ),
    valmistusaika_leaf( BookmarkURI, ShorterTimeClassURI ),
    !.
%writef( 'Must not be %w due to %w\n', [URI, ShorterTimeClassURI] ).


% Succeeds when there is a MASA structure such that MasaTerm1 is
% related term to MasaTerm2
%masa_related_term( ?MasaTerm1, ?MasaTerm2 )
masa_related_term( MasaTerm1, MasaTerm2 ) :-
    % direct case 1
    rdf( MasaTerm1, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-masa#':related_term, MasaTerm2 );
    % direct case 2
    rdf( MasaTerm2, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-masa#':related_term, MasaTerm1 );
    % looping case 1
    rdf( MasaTerm1, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-masa#':related_term, IntermedTerm ),
    masa_related_term( IntermedTerm, MasaTerm2 );
    % looping case 2 (other way around)
    rdf( MasaTerm2, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-masa#':related_term, IntermedTerm ),
    masa_related_term( IntermedTerm, MasaTerm1 ).


% SWI Prolog RDF-piece does not handle numbers too well, we need
% this kind of glue to show it the clue stick
integer_to_atom(Int, Atom) :-
    (   number(Int)
    ->  number_codes(Int, Codes),
        atom_codes(Atom, Codes)
    ;   atom_codes(Atom, Codes),
        number_codes(Int, Codes)
    ).


atom_to_integer(Atom, Int) :-
    integer_to_atom(Int, Atom).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Removes all those resources, that does not have an inbound
% link directly or indirectly from an itemcard.

data_minimizer :-
    findall( A, esinekortti( A ), Cards ),
    forall(
        ( member( Card, Cards ), rdf_traverse( Card ) ),
        ( true )
        ),
    findall( B, 
        (
            rdf( B, _, _),
            not( esinekortti( B ) ), 
            not( knownURI( B )), 
            not( aika( B )),
	    not( muinainen( B )),	
            retractall( rdf( B, _, _))
%            format( 'Retracting subject ~w.~n', [B] )
        ),
        Retracted),
        length( Retracted, Amount ),
        format( 'Retracted ~w subjects.~n', [Amount] )
        .

rdf_traverse( A ) :-
    rdf( A, _, B ),
    B \= literal(_),
    catch( not( knownURI( B ) ), _, true ),
    assert( knownURI( B ) ),
    rdf_traverse( B ).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fix labels

fix_labels :-
    forall(
        (     
            (
                rdf( X, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#':www_kohde, Label );
                rdf( X, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-paikat#':nimi, Label );
                rdf( X, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-toimijat#':toimijan_nimi, Label );
                fail % no label found...
            ),
        retract( rdf( X, 'http://www.w3.org/TR/1999/PR-rdf-schema-19990303#':label, _ ) ),
        assert( rdf( X, 'http://www.w3.org/TR/1999/PR-rdf-schema-19990303#':label, Label ) )
        ),
        true
    ).
