%%%%%%%%%%
% FMSWeb Configuration file for OntoDella Prolog HTTP Server
% Best suited for back-end server, you might need to fix file paths
% etc. to get it working on your test machine.
%
% Author: Arttu Valo
% Version: $Id: ontodella_config.pl,v 1.8 2004/01/20 12:50:31 kimvilja Exp $
%

%get_config_http_port( -Port )
get_config_http_port( 31332 ).

%get_config_rdfs_files( -FileList )
get_config_rdfs_files( FileList ) :-
    FileList = [ 
'data/fms/Esinekortit_lahti.rdf',
'data/fms/Esinekortit_NBA.rdf',
'data/fms/Esinekortit_EKM.rdf',
'data/fms/Esinekortit.rdfs',
'data/fms/muinainen.rdf',
'data/fms/muinainen.rdfs',
'data/fms/paikat.rdf',
'data/fms/paikat.rdfs',
'data/fms/toimijat.rdf',
'data/fms/toimijat.rdfs',
'data/fms/ajat.rdf',
'data/fms/ajat.rdfs',
'data/fms/kokoelmat.rdf',
'data/fms/kokoelmat.rdfs',
'data/fms/mao.rdfs',
'data/fms/maomapping2events.rdf',
'data/fms/uudetsaannot2004-01-07.rdf'
].

% import the SeWeHGrius deduction engine configuration rules
%get_config_load_rules_files/0
get_config_rule_files( FileList ) :-
    FileList = [
'conf/fms/fmsweb_sewehgrius_rules.pl',
'conf/fms/fmsweb_catskip_rules.pl',
'src/prolog/simple_rdfs_distance_recommender.pl'
].

%get_config_load_rules_files :-
%    load_files( [
%        fmsweb_sewehgrius_rules,         % SeWeHGrius API relation rules
%        fmsweb_catskip_rules,            % SeWeHGrius API category skip rules
%        simple_rdfs_distance_recommender % ReKimmender recommendation API rules
%    ], [imports(all)] ).


%get_config_recommendation_logic_file( -RecommLogicFile )
get_config_recommendation_logic_file( simple_rdfs_distance_recommender ).


%get_config_item_count_limit( -ItemCountLimit )
get_config_item_count_limit( 600 ).


% If enabled, scores will be calculated (EXTREMELY SLOW AT THE MOMENT!)
%get_config_use_recommending
get_config_use_recommending :- fail.  %true.


% If enabled, logging will be used (DANGER: thread-problems not yet figured out)
%get_config_use_logging
get_config_use_logging :- true.  % true.

get_config_logger_file( 'ontodella-prolog.log' ).

ontodella_preprocess :-
    write('minimizing the data...\n'),
    ontodella_request_handler:data_minimizer,
    write('fix labels\n'),
    ontodella_request_handler:fix_labels,
    write('cache subclass hierarchy\n'),
    ontodella_request_handler:cache_subclass_hierarchy.
