%%%%%%%%%%
% Sample configuration file for OntoDella Prolog HTTP Server
% Best suited for back-end server, you might need to fix file paths
% etc. to get it working on your test machine.
%
% Author: Arttu Valo
% Version: $Id: ontodella_config.pl,v 1.3 2003/09/21 17:04:19 avalo Exp $
%

%get_config_http_port( -Port )
get_config_http_port( 31332 ).


%get_config_rdfs_files( -FileList )
get_config_rdfs_files( FileList ) :-
    FileList = [ '/home/group/seco/semweb/ontologiat/Annomobiili/Rakennuspalikat/Esinekortit.rdf',
'/home/group/seco/semweb/ontologiat/Annomobiili/Rakennuspalikat/Esinekortit.rdfs',
'/home/group/seco/semweb/ontologiat/Annomobiili/Rakennuspalikat/Paikat.rdf',
'/home/group/seco/semweb/ontologiat/Annomobiili/Rakennuspalikat/Paikat.rdfs',
'/home/group/seco/semweb/ontologiat/Annomobiili/Rakennuspalikat/Toimijat.rdf',
'/home/group/seco/semweb/ontologiat/Annomobiili/Rakennuspalikat/Toimijat.rdfs',
'/home/group/seco/semweb/ontologiat/Annomobiili/Rakennuspalikat/NeoMASA.rdfs' ].


% import the SeWeHGrius deduction engine configuration rules
%get_config_load_rules_files/0
get_config_load_rules_files :-
    load_files( [
        fmsweb_sewehgrius_rules,         % SeWeHGrius API relation rules
        fmsweb_catskip_rules,            % SeWeHGrius API category skip rules
        simple_rdfs_distance_recommender % ReKimmender recommendation API rules
    ], [imports(all)] ).


%get_config_recommendation_logic_file( -RecommLogicFile )
get_config_recommendation_logic_file( simple_rdfs_distance_recommender ).


%get_config_item_count_limit( -ItemCountLimit )
get_config_item_count_limit( 600 ).


% If enabled, scores will be calculated (EXTREMELY SLOW AT THE MOMENT!)
%get_config_use_recommending
get_config_use_recommending :- fail.  %true.


% If enabled, logging will be used (DANGER: thread-problems not yet figured out)
%get_config_use_logging
get_config_use_logging :- true.  % true.
