%%%%%%%%%%
% Simple RDF Schema ontology distance based recommender
% Author: Kim Viljanen
% CVS Id: $Id: simple_rdfs_distance_recommender.pl,v 1.7 2004/03/18 13:32:21 kimvilja Exp $
%


/* *******************************************
combine_ns(NS:Local, URI) :-
	write('combine_ns'),
	nonvar(PropNS),
	nonvar(PropLocal),
	atom_concat(PropNS, PropLocal, URI).

combine_ns(URI, URI).

fms_card_distance(A,B,Distance,Score) :-
	write('').





fms_card_property(Card, Property, Value) :-
	rdf(Card, X, Value)
%	rdf(X, rdf:type, 'http://www.w3.org/1999/02/22-rdf-syntax-ns#Property')
%	rdf(X, Y, Z), 
%	sub_string(X, S, L, A, 'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-esinekortti#'), 
%	S=0,
%	not(rdf(X, 'http://www.w3.org/TR/1999/PR-rdf-schema-19990303#':range, 'http://www.w3.org/TR/1999/PR-rdf-schema-19990303#Literal')).
.





%%% TODO: tss ollaan...


yom_card_distance(A,B,Distance,Score) :-
	findall(
	  [XT, YT, Path, Distance, Score], 
	  (
  	    rdf(A, 'http://www.cs.helsinki.fi/group/seco/yomuseo/Promootio#':mihin_instansseihin_liittyy, X),
  	    rdf(B, 'http://www.cs.helsinki.fi/group/seco/yomuseo/Promootio#':mihin_instansseihin_liittyy, Y),
	    get_type(X,XT), 
	    get_type(Y,YT),
	    distance(XT, YT, Path, Distance, Score)
	  ),
	  Res
        ),
	predsort(distance_result_compare, Res, SortedRes),

	findall([X], rdf(A, 'http://www.cs.helsinki.fi/group/seco/yomuseo/Promootio#':mihin_instansseihin_liittyy, X), Ainsts),
	findall([X], rdf(B, 'http://www.cs.helsinki.fi/group/seco/yomuseo/Promootio#':mihin_instansseihin_liittyy, X), Binsts),

	length(Ainsts, AinstsCount),
	length(Binsts, BinstsCount),
	
	write('Ainsts='), write(AinstsCount), 
	write('\nBinsts='), write(BinstsCount),
	write('\n'),

	ResSize is max(AinstsCount, BinstsCount),

%	write(SortedRes),
%	write('\n\n'),
%	length(Res, ResL),
%	length(SortedRes, SResL),
%	write('ResL='),
%	write(ResL),
%	write(', SResL='),
%	write(SResL),
%	write('\n').
	avg_res(SortedRes, 3, Avg1),
	write('Avg1='),
	write(Avg1),
	write('\n'),
	avg_res(SortedRes, 6, Avg2),
	write('Avg2='),
	write(Avg2),
	write('\n'),
	avg_res(SortedRes, -1, Avg3),
	write('Avg3='),
	write(Avg3),
	write('\n'),
	avg_res(SortedRes,ResSize,Score),
	distance_sum(SortedRes, ResSize, DistanceT),
	Distance is DistanceT/ResSize.

*************************************** */


distance_sum(L, C, D) :-
	distance_sum_1(L, 0, D, C).

distance_sum_1([], D, D, _).

distance_sum_1([L|T], D1, D3, C1) :-
	C1 >= 0,
	res_distance(L,D),
	D2 is D1+D,
	C2 is C1-1,
	distance_sum_1(T, D2, D3, C2).

distance_sum_1(_, D, D, C) :-
	C < 0.

res_distance([_,_,_,D,_], D).


avg_res(L, Max, Avg) :-
	(
	Max > 0 -> 
	  avg_sum_count(L, [], Max, 0, Sum, 0, Count);
	  length(L, LL),
	  avg_sum_count(L, [], LL, 0, Sum, 0, Count)
        ),
%	write('Sum='),
%	write(Sum),
%	write(', Count='),
%	write(Count),
%	write('\n'),
	Div is Count*(Count+1)/2,
	Avg is Sum/Div,
	!.

avg_sum_count([], _, _, Sum, Sum, Count, Count).
%	write('avg_sum_count - 0\n').

avg_sum_count(L, L2, Max, Sum, Sum2, Count, Count2) :-
%	write('avg_sum_count - 1\n'),
	avg_sum_count_1(L, L2, Max, Sum, Sum2, Count, Count2).

avg_sum_count(L, L2, Max, Sum, Sum2, Count, Count2) :-
%	write('avg_sum_count - 2\n'),
	avg_sum_count_1(L, L1, Max, Sum, Sum1, Count, Count1),
	avg_sum_count(L1, L2, Max, Sum1, Sum2, Count1, Count2).

avg_sum_count_1([I|L], L2, Max, Sum, Sum2, Count, Count2) :-
	Count < Max,
	res_score(I, S),
	St is (Max-Count)*S,
	Sum2 is Sum+St,
	Count2 is Count+1,
	L2 = L.

avg_sum_count_1(_, [], Max, Sum, Sum, Count, Count) :-
	Count >= Max.


res_score([_,_,_,_,S], S).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% Used to sort the result...

%%% Sort the result in descending order, highest score first.	

distance_result_compare(Delta, [_,_,_,_,S1], [_,_,_,_,S2]) :-
	S1 < S2,
	Delta = '>'.

distance_result_compare(Delta, [_,_,_,_,S1], [_,_,_,_,S2]) :-
	S1 = S2,
	Delta = '>'.

distance_result_compare(Delta, [_,_,_,_,S1], [_,_,_,_,S2]) :-
	S1 > S2,
	Delta = '<'.




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%% Calculate distance between A and B

distance(A, A, [], 0, 1):- !. % our policy: prune the simple cases as soon as possible.

distance(A, B, [], 0, 0):-
	node_prune_rule(A);
	node_prune_rule(B).

distance(A, B, Path, Distance, Score) :-
	get_from_distance_cache(A, B, Path, Distance, Score),
%	sformat( ResultS, "found from cache: A:~w, B:~w", [A, B] ),
%	thread_send_message( httpdlogger, ResultS ),
	!.

distance(A, B, Path, Distance, Score) :-
%	format('******* distance (~w => ~w)~n', [A,B]),
	ScoreMin=0.1,

	% calculate distance A to B

	distance(A, B, Path1, Distance1, Score1, ScoreMin),

%	format('result from: distance#2 A->B: D=~w, S=~w', [Distance1, Score1]),

	sort([ScoreMin, Score1], SList), % If Score1 > ScoreMin, use the Score1 as limit. (compare to alpha-delta-pruning)
	last(SList, ScoreMin2),
	!,

	(

	    % calculate distance B to A

	    distance(B, A, Path2, Distance2, Score2, ScoreMin2),

%	    format('result from: distance#2 B->A: D=~w, S=~w', [Distance2, Score2]),

	    Score1 > Score2 -> (
	       Score = Score1,
	       Path = Path1,
	       Distance = Distance1;
	       Score = Score2,
	       Path = Path2,
	       Distance = Distance2),
	    !;
	    Score = Score1,
	    Distance = Distance1,
	    Path = Path1,
	    !
	),

	add_to_distance_cache(A, B, Path, Distance, Score)

%	sformat( S, "distance: Calculate distance (A=~w, B=~w)", [A, B] ),
%	thread_send_message( httpdlogger, S ),
%
%	sformat( ResultS, "distance#1 result: Path: ~w; Distance: ~w; Score: ~w", [Path, Distance, Score] ),
%	thread_send_message( httpdlogger, ResultS )
	.

distance(_,_,_,_,0).

distance(A, B, Path, Distance, Score,ScoreMin) :-
%	format('~n********* distance#2 (~w => ~w, scoremin=~w)~n', [A,B,ScoreMin]),
	traverse(A,C1,Path1,S1,_,ScoreMin),
	traverse(B,C2,Path2,_,InvS2,ScoreMin),
	C1=C2,

	%%%%% epilyttv koodi alkaa... (Voisiko tmn kirjoittaa jrkevmmin?)

	(
	  last(LastElemInPath2, Path2) -> 
	    delete(Path2, LastElemInPath2, Path2B),
	    last(Path1, LastItem),
	    last(Path2B, LastItem) ->
	    (
		append(Path2pruned, [LastItem], Path2B); % prune the last item
		Path2pruned = Path2B
	    ),
  	    reverse(Path2pruned, Path2Rev),
	    append(Path1, Path2Rev, PathTemp);
 	    PathTemp=Path1
	),

	delete(PathTemp, A, PathTemp1),
	delete(PathTemp1, B, Path),

	%%%%% ...epilyttv koodi loppuu

	length(Path, Length),
	Distance is Length+1,
%	Score is S1*S2.
	Score is S1*InvS2,

%       format('S1*InvS2=~w*~w=~w~n', [S1, InvS2, Score]),

%	format( "======= distance#2 result: Path: ~w; Distance: ~w; Score: ~w~n~n", [Path, Distance, Score] ),
	!
	.




% pseudo...
%
% Score1 is S1*InvS2
% Score2 is S2*InvS1
% Score is min(Score1, Score2)



%	write('\n Path1='),
%	write(Path1),
%	write('\n Path2='),
%	write(Path2),
%	write('\n S1='),
%	write(S1),
%	write('\n S2='),
%	write(S2),
%	!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Predicates for traversing the rdf graph.

traverse(A,A,[],1,1,_).

traverse(A,B,Path,S,InvS,SMin) :-
	traverse_many(A,B,[],Path,1,S,1,InvS,SMin),
	S*InvS>SMin.
%	write('//////////////// pruned\n'), fail. % if result is less than S*InvS, we are not interested in it!

traverse_many(A,B,Path1,Path2,S1,S2,InvS1,InvS2,SMin) :-
	traverse_one(A,B,Path1,Path2,S1,S2,InvS1,InvS2,SMin).
%	write('tvm#1 return\n').

traverse_many(A,B,Path1,Path2,S1,S2,InvS1,InvS2,SMin) :-
	traverse_one(A,C,Path1,Path,S1,S,InvS1,InvS,SMin),
	traverse_many(C,B,Path,Path2,S,S2,InvS,InvS2,SMin).
%	write('tvm#2 return\n').

traverse_one(A,B,Path1,Path2,S1,S2,InvS1,InvS2,SMin) :-
	relation_to_right(A,B,_,W,InvW),
%	catch(
%	  (
%	    not(relation_halt_node(A)),
%	    not(relation_halt_node(B))
%	  ), _, true),
	append(Path1, [B], Path2),
%	not(path_prune_rule(Path2)),
	S2 is S1*W,
	InvS2 is InvS1*InvW,
	S2>SMin.
%	format('S2>SMin: ~w>~w~n', [S2,SMin]),
%	write('traverse one: return\n').

% pitisik mys tarkistaa onko InvS2>SMin ??

%write('traverse_one: A->B '),
%write(A),
%write('->'),
%write(B),
%write('\n').

relation(A,B,R,W,InvW) :-
	relation_to_right(A,B,R,W,InvW);
	relation_to_left(A,B,R,W,InvW).

relation_to_right(A,B,R,W,InvW) :-  %%% left to right
	nonvar(A),
	var(B),
	not(node_prune_rule(A)), % prune nodes that does not make sence
	relation_data(R, W, InvW),
	nonvar(W),
	W\=0,
	rdf(A,R,B),
	not(node_prune_rule(B)),
	!.
%	format('--> rdf(~w, ~w, ~w)~n', [A, R, B]).

relation_to_left(A,B,R,W,InvW) :-  %%% right to left
	var(A),
	nonvar(B),
	not(node_prune_rule(B)), % prune nodes that does not make sence
	relation_data(R, InvW, W),
	nonvar(W),
	W\=0,
	rdf(A,R,B),
	not(node_prune_rule(A)),
	!.
%	format('<-- rdf(~w, ~w, ~w)~n', [A, R, B]).




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Data (this should be read from a config file)...

relation_data('http://www.w3.org/TR/1999/PR-rdf-schema-19990303#':subClassOf, 0.5, 0.9).
%relation_data(rdf:type, 0.8, 0.2).
%relation_halt_node('http://www.w3.org/TR/1999/PR-rdf-schema-19990303#Resource').



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% if path_prune_rule evaluates true, then this path is useless

path_prune_rule(Path) :-
	member('http://www.w3.org/TR/1999/PR-rdf-schema-19990303#Resource', Path).
%	format('path prune: path=~w~n', [Path]).

node_prune_rule('http://www.w3.org/TR/1999/PR-rdf-schema-19990303#Resource').
%	write('node prune: #Resource\n').



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Some handy predicates...

get_type(I,C) :-
        not(rdf(I, rdf:type, 'http://www.w3.org/TR/1999/PR-rdf-schema-19990303#Class')),
        rdf(I, rdf:type, C).

get_type(I,C) :-
        rdf(I, rdf:type, 'http://www.w3.org/TR/1999/PR-rdf-schema-19990303#Class'),
        C=I.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Simple cache
%
% Should be thread safe, since only one atom added. So no mutexis needed here.

add_to_distance_cache(A,B,Path,Distance,Score) :-
	writelog( "adding to cache: Path: ~w; Distance: ~w; Score: ~w", [Path, Distance, Score] ),
	assert(cache_simple_rdfs_distance(A,B,Path,Distance,Score)).

get_from_distance_cache(A,B,Path,Distance,Score) :-
	nonvar(A),
	nonvar(B),
	catch(
 	     cache_simple_rdfs_distance(A,B,Path,Distance,Score),
	     _,
	     fail),
%	writelog( 'distance cache fetch [~w, ~w, ~w, ~w, ~w]', [A,B,Path,Distance,Score] ),
	!.